#!/usr/bin/env python
# -*- coding:utf-8 -*-
import sys
from PyQt4 import QtGui, QtCore
import time,os,threading

class Example(QtGui.QWidget):
     
    def __init__(self,spath,dpath):
        super(Example, self).__init__()
        self.spath=spath
        self.dpath=dpath
        self.threads=[] 
        self.initUI()
    def initUI(self):
        	
        self.realpath=self.spath.replace('*','')
        self.deb_num=os.popen("find "+self.realpath+"|grep deb$|wc -l").readline().strip()
        self.deb_tio_num=os.popen("find "+self.realpath+"预装软件/*三合一/"+"|grep deb$|wc -l").readline().strip()
        self.deb_new=int(self.deb_num)-int(self.deb_tio_num)+1

        self.text=u"正在同步预装软件,总计{}个deb软件包,请稍等...".format(str(self.deb_new))
        
        self.allsize=os.popen("du -s "+self.spath.replace('*','')).readline().split('\t')[0]
        self.pbar = QtGui.QProgressBar(self)
        self.pbar.setGeometry(40, 40, 400, 25)
 
#        self.btn = QtGui.QPushButton('Start', self)
#        self.btn.move(40, 80)
#        self.btn.clicked.connect(self.timerEvent)
        self.setGeometry(832, 451, 500, 170)
        self.setWindowTitle(u"预装软件包同步进度")
        
        self.label=QtGui.QLabel(self.text,self) 
        self.label.move(100,80)             
        self.label1=QtGui.QLabel(self)
        self.label1.move(140,95)             
#        self.setWindowFlags(QtCore.Qt.CustomizeWindowHint)
        self.setWindowFlags(QtCore.Qt.WindowCloseButtonHint)
        self.timer = QtCore.QBasicTimer()
        self.step = 0
        self.time1=time.time()
        t1=threading.Thread(target=self.syncsoftware)
	self.threads.append(t1)
        t2=threading.Thread(target=self.starttimer)
        self.threads.append(t2)
        
        for i in range(len(self.threads)):
            self.threads[i].start()
            print self.threads[i]
#        for i in range(len(self.threads)):
#            self.threads[i].join()
#        self.timer.start(300,self)
#        print self.timer.isActive()
#        self.show()
    def starttimer(self):
        self.timer.start(300,self)

    def syncsoftware(self):
        os.system('cp '+self.spath+' '+self.dpath+' -r')
               
    def getSpeed(self,size):
        self.time2=time.time()
        self.time_zone=float(self.time2-self.time1)
        print self.time_zone
        self.speed=int(float(self.softsize)/self.time_zone)
        self.speed_real=round(float(self.speed)/float(1000))
        return self.speed_real 
    def timerEvent(self,event): 
        self.softsize=os.popen("du -s "+self.dpath).readline().split('\t')[0]
        self.percent=float(self.softsize)/float(self.allsize)
        self.tmp_step=int(self.percent*100)
        
        if self.step >= 100:
           self.timer.stop()
           os._exit(0)
        self.step = self.tmp_step
        self.pbar.setValue(self.step)
        #self.speed_text=u"同步速率:{}Mb/s".format(str(self.speed_real))
        #print self.speed_text
        #time.sleep(0.5)
          
            
       
         
 
#if __name__ == '__main__':
#    app = QtGui.QApplication(sys.argv)
#    ex = Example(spath,dpath)
#    ex.show()
#    sys.exit(app.exec_())
 
 
